val warning : string -> unit
val error : string -> 'a
type loc = { line : int; char : int; file : string option; }
type 'a psr = loc -> char Stream.t -> loc * 'a
val run_parser : string option -> 'a psr -> char Stream.t -> 'a
val parse_file : 'a psr -> string -> 'a
val parse_channel : 'a psr -> in_channel -> 'a
val parse_string : 'a psr -> string -> 'a
val string_of_loc : loc -> string
val ( <$> ) : ('a -> 'b) -> 'a psr -> 'b psr
val pure : 'a -> 'a psr
val ( <*> ) : ('a -> 'b) psr -> 'a psr -> 'b psr
val ( >>= ) : 'a psr -> ('a -> 'b psr) -> 'b psr
val fail : 'a psr
val ( <|> ) : 'a psr -> 'a psr -> 'a psr
val ( <* ) : 'a psr -> 'b psr -> 'a psr
val ( *> ) : 'a psr -> 'b psr -> 'b psr
val ( <$ ) : 'a -> 'b psr -> 'a psr
val choice : 'a psr list -> 'a psr
val ( <?> ) : 'a psr -> string -> 'a psr
val many : 'a psr -> 'a list psr
val many_1 : 'a psr -> 'a list psr
val end_by : 'a psr -> 'b psr -> string -> 'a list psr
val sep_by : 'a psr -> 'b psr -> string -> 'a list psr
val many_s : char psr -> string psr
val many_1s : char psr -> string psr
val set_loc : (loc -> loc) -> unit psr
val inc_char : unit psr
val inc_line : unit psr
val get_loc : loc psr
val get_char : int psr
val get_line : int psr
val _char_if : (char -> bool) -> char psr
val _char : char -> unit psr
val nl : unit psr
val char_if : (char -> bool) -> char psr
val char : char -> unit psr
val none_of : string -> char psr
val some_of : string -> char psr
val any : char psr
val hs : unit psr
val ws : unit psr
val line : string psr
val smart_line : string psr
val lines : string list psr
val smart_lines : string list psr
