open Util
open Parsec

(* gets parameter from _ussm/settings, with a default fallback *)
let default_param param default () = try Header.from_conf param with _ -> default
let default_language  = default_param "default-language"  "en"
let default_extension = default_param "default-extension" "txt"

(* extract (language, extension) from a file name *)
let name_lang : string -> (string * string) = fun name ->
  match name |> parse_string (sep_by (many_s (none_of ".")) (char '.') "")
             |> List.rev
  with
    | _ :: name :: []   -> (name, default_language ())
    | _ :: lang :: name -> (name |> List.rev |> String.concat ".", lang)
    | _                 -> error ("file name " ^ name ^" have no extension")

let language : string -> string = name_lang |- snd
