#! /bin/sh

# Generates the main section of each page.
# Usage: ussm-core
#
# Input:    every foo/bar.txt source file.
# Output:   a _ussm/tmp/foo/bar.core for each foo/bar source file.
# parameter: $(ussm-setting html-processor)
#            This is the name of a UNIX filter (cat, markdown...)
#
# It takes the main part of each source file, gives it to the
# html_processor, then outputs
# the result.
#
# We can choose another processor on a file-by-file basis, by setting the
# 'html-generator' heading.

if [ $# -ne 0 ]; then
    echo "$0 doesn't take any argument" >&2
    exit 1
fi


html_processor=$(ussm-setting html-processor)


for source in $(ussm-source-files); do
    mkdir -p _ussm/tmp/$(dirname $source)
    dest=_ussm/tmp/$(echo "$source" | sed 's/\.[^.]*$//').core
    ussm-strip-header $source | $html_processor > $dest
done
