#! /bin/sh

# List every source file in the USSM repository (one file name per
# line, path relative to the USSM root directory)
#
# A source file is a file that:
#  1. has a name ending by .$(ussm-setting source-extension)
#  2. begins by a valid header (even if it's just "{}").

default_extension=$(ussm-setting source-extension)

if [ $# -ge 1 ]; then
    echo "$0 doesn't take any argument" >&2
    exit 1
fi

for source in $(find . -name "_ussm" -prune -o -print |\
                  ussm-remove-boring                  |\
                  grep "\."$default_extension"$"      |\
                  sed 's|^\./||')
do
    ussm-heading "" "$source" 2>/dev/null && echo "$source"
done
