open Util

let (warning, error) = mk_error "ussm"

let main () = match Array.length Sys.argv with
  | 1 | 2 ->
    let language = if Array.length Sys.argv = 1
                   then "en"
                   else Sys.argv.(1) in
    (match ussm_root "." with
      | Some dir -> Sys.chdir dir; command "_ussm/ussm"
      | None     ->
        print_string ("This is not a ussm repository.  " ^
                      "Do you want me to create one? (y/N)");
        let answer = String.lowercase (read_line ()) in
        if answer = "" || answer.[0] <> 'y'
        then (print_endline "Okay, I do nothing.")
        else command ("ussm-init " ^ language))

  | _ -> error "usage: ussm [ln]"

let _ = standard_exit main
