open Util

let (warning, error) = mk_error "ussm"

(* copy the repository, then reports true for failure, or false for success *)
let copy_repository : string -> bool = fun dir ->
  if Sys.file_exists dir
  then (command ("cp -r " ^ dir ^"/* ./"); true)
  else false

let main () = match Array.length Sys.argv with
  | 2 ->
    (match ussm_root "." with
      | None     -> () (* No ussm repository in sight, we can go on *)
      | Some dir -> error ("I am already in a ussm repository: " ^ dir ^
                           "\nI won't create nested directories. " ^
                           "Could you please try elsewere?"));

    let language = Sys.argv.(1) in
    if   let home = try Sys.getenv "HOME" with Not_found -> "/nowhere" in
         copy_repository (home ^ "/.ussm/"   ^ language) then ()
    else if copy_repository ("/etc/ussm/" ^ language) then ()
    else error ("Cannot find the default configuration files. \n" ^
                "Please check ~/.ussm/"^ language ^" and /etc/ussm/"^ language)

  | _ -> error "usage: ussm-init [ln]"

let _ = standard_exit main
