(** Removes the header from a given file (or the standard input),
    then prints main text in the standard output.

    usage: ussm-strip-header [filename]

    returns 0 if all goes well, 1 for fatal errors
    If it returns 2 (uncaught exception), you found a bug.
*)

open Util
open Parsec

let(warning, error) = mk_error "ussm-strip-header"

let main () =
  try
    match Array.length Sys.argv with
      | (1 | 2) as argv_len ->

        let input = Stream.of_channel
          (if argv_len = 2 then open_in Sys.argv.(1) else stdin) in
        let input_name =
          (if argv_len = 2 then Some Sys.argv.(1)    else None ) in

        (* Strip the header, print the rest, cleanup *)
        ignore (run_parser input_name Header.header input);
        Stream.iter print_char input;
        flush stdout;

      | _ -> error "usage: ussm-strip-header [filename]"
  with
      Exit -> exit 1

let _ = standard_exit main
