open Util

type t = Raw of string
       | Tag of string * (string * string) list * t list

let simple_tag : string -> t list -> t =
  fun tag content -> Tag (tag, [], content)

let escape : string -> string = id (* TODO.  Mind the not-so subtle bugs *)

(* pretty-prints XML, except it's NOT pretty. Yet. *)
let rec text_of_xml : t -> string = (function
  | Raw text                       -> escape text
  | Tag (tag, attributes, content) ->
    ("<" ^ tag) :: (List.map
                      (fun (k, v) -> " " ^ k ^ "=" ^ "\"" ^ v  ^ "\"")
                      attributes)
    @ (">" :: List.map text_of_xml content)
    @ ["</" ^ tag ^ ">"]
    |> String.concat "\n")
